/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.baselibs;

import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.enums.EnumFrameType;
import cdac.medinfo.sdk.dcm30_04.exceptions.ConditionFailedException;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidItemException;
import cdac.medinfo.sdk.dcm30_04.exceptions.ValidationException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;

/**
* This item class contains the methods to set, get and validate the attribute present in PET Position Sequence.
 */

public class PETPositionSequenceItem extends Item
{
	


	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * This constructor creates the item with default TransferSyntax 
	 */
	PETPositionSequenceItem()
	{
		super();
	}

	/*
	 * This constructor calls the respective superclass constructor
	 * This constructor should throw exception if null TS is tried to be set
	 */
	/**
	 * This constructor creates the item with specified TransferSyntax 
	 * and default DictionaryReader
	 * @param objITransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 */
	PETPositionSequenceItem(ITransferSyntax objITransferSyntax)
	{
		super(objITransferSyntax);
	}

	/**
	 * This constructor creates PETPositionSequenceItem with specified TransferSyntax and
	 * specified DictionaryReader.
	 * @param objTransferSyntax specifies the DICOM Standard defined TransfeSyntax.
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used.
	 */
	PETPositionSequenceItem(ITransferSyntax objTransferSyntax, IDictionaryReader objDictionaryReader)
	{
		super(objTransferSyntax,objDictionaryReader);
	}

	/*
	 * (non-Javadoc) This method validates the contents of the Item
	 * @see cdac.medinfo.sdk.dcm30_04.commoninterface.IItem#validate()
	 */
	/**
	 * Validates all the attributes in PETPositionSequenceItem that are present in the DataSet
	 * @return boolean - Success -true, Failure - false
	 * @throws InvalidItemException throws InvalidItemException If Mandatory or Conditional element fails.
	 */
	public boolean validateForModule()  throws InvalidItemException
	{
		try{
			if(getDataForTag(0x0008, 0x9007).getValue().equals(EnumFrameType.Value1.ORIGINAL)){
				if(!contains(0x0018,0x9327))
					throw new ConditionFailedException("0x0018,0x9327");
				if(!contains(0x0018,0x9313))
					throw new ConditionFailedException("0x0018,0x9313");
				if(!contains(0x0018,0x9318))
					throw new ConditionFailedException("0x0018,0x9318");
			}
		}
		catch(ConditionFailedException ce)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(ce.getMessage());
			}
			throw new ValidationException(this.getClass().getSimpleName(),ce); 
		}
		return true;
	}
	
	/**
	 * Sets the Table Position.
	 * @param dblTablePosition Double value of Table Position
	 */
	public void setTablePosition(double dblTablePosition)
	{
		/*Accept the Table Position in double format of type FD.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0018,0x9327, dblTablePosition,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0018,0x9327,DicomConstants.DCM_DT_FD, dblTablePosition);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves the Minimal value of Chemical Shift Frequency in ppm.
	 * @return double - double value of ChemicalShiftsMinimumIntegrationLimitOnppm
	 */
	public double getTablePosition()
	{
		Object objValue = getValue(0x0018,0x9327);
		if(objValue != null)
			return Double.parseDouble(objValue.toString());
		return DicomConstants.DCM_NO_VALUE;
	}
	
	/**
	 * Sets the Data Collection Center Patient.
	 * @param dblArrDataCollectionCenterPatient Double value of Data Collection Center Patient
	 */
	public void setDataCollectionCenterPatient(double[] dblArrDataCollectionCenterPatient)
	{
		/*Accept the Data Collection Center Patient in double format of type FD.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0018,0x9313, dblArrDataCollectionCenterPatient,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0018,0x9313,DicomConstants.DCM_DT_FD, dblArrDataCollectionCenterPatient);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves the Data Collection Center Patient.
	 * @return double - double value of Data Collection Center Patient
	 */
	public double[] getDataCollectionCenterPatient()
	{
		Object objValue = getValue(0x0018,0x9313);
		if(objValue != null)
			return (double[])objValue;
		return null;
	}
	
	/**
	 * Sets the Reconstruction Target Center Patient.
	 * @param dblArrReconstructionTargetCenterPatient Double value of Reconstruction Target Center Patient
	 */
	public void setReconstructionTargetCenterPatient(double[] dblArrReconstructionTargetCenterPatient)
	{
		/*Accept the Reconstruction Target Center Patient in double format of type FD.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0018,0x9318, dblArrReconstructionTargetCenterPatient,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0018,0x9318,DicomConstants.DCM_DT_FD, dblArrReconstructionTargetCenterPatient);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves the Reconstruction Target Center Patient.
	 * @return double - double value of Reconstruction Target Center Patient
	 */
	public double[] getReconstructionTargetCenterPatient()
	{
		Object objValue = getValue(0x0018,0x9318);
		if(objValue != null)
			return (double[])objValue;
		return null;
	}
}
